#include "defines.h"
#include "serial.h"
#include "xmodem.h"
#include "elf.h"
#include "lib.h"

static int init(void)
{
  /* ȉ̓JEXNvgŒ`ĂV{ */
  extern int erodata, data_start, edata, bss_start, ebss;

  /*
   * f[^̈BSS̈D̏ȍ~łȂƁC
   * O[oϐĂȂ̂ŒӁD
   */
  memcpy(&data_start, &erodata, (char *)&edata - (char *)&data_start);
  memset(&bss_start, 0, (char *)&ebss - (char *)&bss_start);

  /* VȀ */
  serial_init(SERIAL_DEFAULT_DEVICE);

  return 0;
}

/* 16i_vo */
static int dump(char *buf, long size)
{
  long i;

  if (size < 0) {
    puts("no data.\n");
    return -1;
  }
  for (i = 0; i < size; i++) {
    putxval(buf[i], 2);
    if ((i & 0xf) == 15) {
      puts("\n");
    } else {
      if ((i & 0xf) == 7) puts(" ");
      puts(" ");
    }
  }
  puts("\n");

  return 0;
}

int main(void)
{
  static char buf[16];
  static long size = -1;
  static unsigned char *loadbuf = NULL;
  extern int buffer_start; /* JEXNvgŒ`Ăobt@ */

  init();

  puts("kzload (kozos boot loader) started.\n");

  while (1) {
    puts("kzload> "); /* vvg\ */
    gets(buf); /* VÃR}hM */

    if (!strcmp(buf, "load")) { /* XMODEMł̃t@C̃_E[h */
      loadbuf = (char *)(&buffer_start);
      size = xmodem_recv(loadbuf);
      if (size < 0) {
	puts("XMODEM receive error!\n");
      } else {
	puts("XMODEM receive succeeded.\n");
      }
    } else if (!strcmp(buf, "dump")) { /* 16i_vo */
      puts("size: ");
      putxval(size, 0);
      puts("\n");
      dump(loadbuf, size);
    } else if (!strcmp(buf, "run")) { /* ELF`t@C̎s */
      elf_load(loadbuf); /* ɓWJ([h) */
    } else {
      puts("unknown.\n");
    }
  }

  return 0;
}
