#include "defines.h"
#include "kozos.h"
#include "lib.h"
#include "memory.h"

/*
 * EubN\
 * (lꂽë́C擪Ɉȉ̍\̂Ă)
 */
typedef struct _kzmem_block {
  struct _kzmem_block *next;
  int size;
} kzmem_block;

/* Ev[ */
typedef struct _kzmem_pool {
  int size;
  int num;
  kzmem_block *free;
} kzmem_pool;

/* Ev[̒`(X̃TCYƌ) */
static kzmem_pool pool[] = {
  { 16, 8, NULL }, { 32, 8, NULL }, { 64, 4, NULL },
};

#define MEMORY_AREA_NUM (sizeof(pool) / sizeof(*pool))

/* Ev[̏ */
static int kzmem_init_pool(kzmem_pool *p)
{
  int i;
  kzmem_block *mp;
  kzmem_block **mpp;
  extern char freearea; /* JEXNvgŒ`󂫗̈ */
  static char *area = &freearea;

  mp = (kzmem_block *)area;

  /* Ẍׂ̗ĉς݃NXgɌq */
  mpp = &p->free;
  for (i = 0; i < p->num; i++) {
    *mpp = mp;
    memset(mp, 0, sizeof(*mp));
    mp->size = p->size;
    mpp = &(mp->next);
    mp = (kzmem_block *)((char *)mp + p->size);
    area += p->size;
  }

  return 0;
}

/* Ȉ */
int kzmem_init(void)
{
  int i;
  for (i = 0; i < MEMORY_AREA_NUM; i++) {
    kzmem_init_pool(&pool[i]); /* eEv[ */
  }
  return 0;
}

/* I̊l */
void *kzmem_alloc(int size)
{
  int i;
  kzmem_block *mp;
  kzmem_pool *p;

  for (i = 0; i < MEMORY_AREA_NUM; i++) {
    p = &pool[i];
    if (size <= p->size - sizeof(kzmem_block)) {
      if (p->free == NULL) { /* ςݗ̈悪(EubNs) */
	kz_sysdown();
	return NULL;
      }
      /* ς݃NXg̈擾 */
      mp = p->free;
      p->free = p->free->next;
      mp->next = NULL;

      /*
       * ۂɗp\ȗ̈́CEubN\̗̂̒̈
       * Ȃ̂ŁC̃AhXԂD
       */
      return mp + 1;
    }
  }

  /* w肳ꂽTCŸ̗i[ł郁Ev[ */
  kz_sysdown();
  return NULL;
}

/* ̉ */
void kzmem_free(void *mem)
{
  int i;
  kzmem_block *mp;
  kzmem_pool *p;

  /* ̈̒Oɂ(͂)EubN\̂擾 */
  mp = ((kzmem_block *)mem - 1);

  for (i = 0; i < MEMORY_AREA_NUM; i++) {
    p = &pool[i];
    if (mp->size == p->size) {
      /* ̈ς݃NXgɖ߂ */
      mp->next = p->free;
      p->free = mp;
      return;
    }
  }

  kz_sysdown();
}
